Require Extraction.
Require Import List. 
Print list.

Print list_ind.
Check cons.
Definition a := 3::nil.
Print a.
Extraction a.
 
Fixpoint app (A:Set) (l m: list A){struct l}:list A :=
match l with
|nil => m
|cons a l1 => cons a (app A l1 m)
end.

Extraction app.

Fixpoint length (A:Set) (l: list A){struct l}: nat :=
match l with
nil => 0 |
cons a l' => 1 + (length A l')
end.

Definition add_one (A:Set) (l:list A) (a: A):list A:= a::l.

Theorem ss: forall (A:Set) (l:list A) (a:A), (length A (add_one A l a)) =
  (length A l ) +1.
Proof.
intros.
induction l.
simpl.
reflexivity.
simpl.
auto.
Qed.

Print ss.

Definition two_first (A:Set)(l:list A) : list A :=
 match l with a :: b :: l' => a :: b :: nil
            | other => nil
 end.

Eval compute in (two_first _ (true::false::true::nil)).

Eval compute in (two_first _ ((6 * 6)::nil)).

Fixpoint firsts (A:Set)(n:nat)(l:list A){struct n}: list A :=
   match (n,l) with
     (0, l') => nil
   | (S n', nil) => nil
   | (S n', a::l') => a::(firsts _ n' l')
  end.

Fixpoint suml (l:list nat): nat :=
   match l with
   |  nil => 0
   | n::l' => n + suml l'
  end.

Eval compute in (suml (1::7::8::nil)).

Fixpoint listn (n:nat): list nat:=
  match n with
| 0 => nil
| S n => (listn n) ++ S n::nil
end.


Eval compute in (listn 5).

(*funções parciais *)

Print option.

Definition predc (n:nat):option nat:=
match n with O => None | S p => Some p end.


(* pares *)

Print prod.

Print fst.

Fixpoint split (A B: Set)(l: list (A * B)) {struct l} : (list A)*(list B) :=
 match l with nil => (nil, nil)
            | (a,b)::l' => (let (l'1,l'2) := split _ _ l' 
                           in (a::l'1, b::l'2))
         end.

(* soma disjunta *)

Print sum.

(* Tipos indutivos dependentes *)

Inductive ltree (n:nat) : Set:=
| lleaf : ltree n
| lnode : forall p:nat, p<= n -> ltree n -> ltree n -> ltree n.

Print ltree_rect.


Inductive htree (A:Set) : nat->Set :=
  | hleaf : A->htree A 0
  | hnode : forall n:nat, A -> htree A n -> htree A n -> htree A (S n).

Check htree_ind.


Require Export ZArith.
Open Scope Z_scope. 

Inductive Z_btree : Set :=
  Z_leaf : Z_btree | Z_bnode : Z->Z_btree->Z_btree->Z_btree.

Fixpoint htree_to_btree (n:nat)(t:htree Z n){struct t} : Z_btree :=
  match t with
  | hleaf _ x => Z_bnode x Z_leaf Z_leaf
  | hnode  _ p v t1 t2 =>
      Z_bnode v (htree_to_btree p t1)(htree_to_btree p t2)
  end.

Fixpoint invert (A:Set)(n:nat)(t:htree A n){struct t} : htree A n :=
  match t in htree _ x return htree A x with
  | hleaf  _ v => hleaf A v
  | hnode _ p v t1 t2 => hnode A p v (invert A p t2)(invert A p t1)
  end.


(* Tipos vazios *)
Print Empty_set.

 Print Empty_set_ind.


Print False.
Print False_ind.

Inductive strange : Set := cs : strange -> strange.

Theorem strange_empty : forall x:strange, False.
Proof.
intro K.
elim K.
intros Kq H.
assumption.
Qed.

Print strange_empty.
